#include <iostream>
#include "BasicTypesLists.h"
#include "CustomTypes.h"
#include "SocketStream.h"
#include "SocketException.h"
#include <map>
#include <vector>
#include <limits.h>


int main(void)
{
    SocketStream ss;
	try
	{
		 // Connection to localhost
		 ss.connect("127.0.0.1", 9090);
		 // Creation of an instance of BasicTypesLists
		 std::vector<char> aByteList;
		 aByteList.push_back((char)CHAR_MIN);
		 aByteList.push_back((char)CHAR_MAX);

		 std::vector<short> aShortList;
		 aShortList.push_back(SHRT_MIN);
		 aShortList.push_back(SHRT_MAX);

		 std::vector<int> aIntList;
		 aIntList.push_back(INT_MIN);
		 aIntList.push_back(INT_MAX);

		 std::vector<long long> aLongList;
		 aLongList.push_back(LLONG_MIN);
		 aLongList.push_back(LLONG_MAX);

		 std::vector<float> aFloatList;
		 aFloatList.push_back(1);
		 aFloatList.push_back(2);
		 aFloatList.push_back(3);

		 std::vector<double> aDoubleList;
		 aDoubleList.push_back(1);
		 aDoubleList.push_back(2);
		 aDoubleList.push_back(3);

		 std::vector<bool> aBooleanList;
		 aBooleanList.push_back(true);
		 aBooleanList.push_back(false);

		 std::vector<std::string> aStringList;
		 aStringList.push_back("Hello");
		 aStringList.push_back("world !");

		 BasicTypesLists basiclists;
		 basiclists.setAByteList(aByteList);
		 basiclists.setAShortList(aShortList);
		 basiclists.setAIntList(aIntList);
		 basiclists.setALongList(aLongList);
		 basiclists.setADoubleList(aDoubleList);
		 basiclists.setAFloatList(aFloatList);
		 basiclists.setABooleanList(aBooleanList);
		 basiclists.setAStringList(aStringList);
		 // Insertion in map
		 map<int,Object*> mapToSend;
		 mapToSend[0] = &basiclists;
		 // Encoding of the map
		 CustomTypes::encodeData(mapToSend, ss);
		 // Closing socket attached to SocketStream ss
		 ss.close();

	}
	catch(SocketException& e)
	{
		 std::cout<<e.description();
	}

}
