#include <iostream>
#include "ObjectA.h"
#include "ObjectB.h"
#include "ObjectC.h"
#include "CustomTypes.h"
#include "SocketStream.h"
#include "SocketException.h"
#include <map>
#include <vector>

int main(void)
{
	SocketStream ss;
	try
	{
		// Connection to localhost
		ss.connect("127.0.0.1", 9090);
		// Creation of instances of ObjectA, ObjectB and ObjectC
		ObjectA objectA;
		ObjectC objectC1;

		ObjectB objectB;
		ObjectC objectC2;
		ObjectC objectC3;

		std::vector<ObjectC> vObjectCforB;

		objectC1.setAString("un");
		objectC2.setAString("deux");
		objectC3.setAString("trois");

		objectA.setObjectC(objectC1);

		vObjectCforB.push_back(objectC2);
		vObjectCforB.push_back(objectC3);

		objectB.setObjectC(vObjectCforB);

		// Insertion in map
		map<int,Object*> mapToSend;
		mapToSend[0] = &objectA;
		mapToSend[1] = &objectB;
		// Encoding of the map
		CustomTypes::encodeData(mapToSend, ss);
		// Closing socket attached to SocketStream ss
		ss.close();
	}
	catch(SocketException& e)
	{
		std::cout<<e.description();
	}

}
