package tests;

import junit.framework.*;
import objectTypes.server.*;
import objectTypes.*;
import java.util.*;
import java.io.*;

public class TestObjectTypes extends TestCase
{
	// Path to the C++ client executable compiled by cpptask in pom.xml
	public static final String objectTypesExecutableFile = "./target/execObjectTypes";
	
	public void testClientServerObjectTypesExchange () throws Exception{
	    // Server initialisation 
        LittleServer server = LittleServer.getInstance();
        // Server waiting for client then C++ client connection 
    	server.launchClientToServerCommunication(objectTypesExecutableFile);
		DataInputStream dataInputStream = server.getDataInputStream();
		try{
			// Reception of C++ client's hashtable
			Hashtable serverDecodedMap = (new objectTypes.server.CustomTypes()).decodeData(dataInputStream);
			ObjectA objectA = (ObjectA) serverDecodedMap.get("0");
			ObjectB objectB = (ObjectB) serverDecodedMap.get("1");
			
			assertTrue(objectA.getObjectC().getAString().equals("un"));
			assertTrue(objectB.getObjectC()[0].getAString().equals("deux"));
			assertTrue(objectB.getObjectC()[1].getAString().equals("trois"));
			
		}catch (IOException e){
			e.printStackTrace();
		}finally{
			server.stop();
		}		
	}
}
