/** 
 * MooDS Game Server Logic for Java.
 * @author Generated by MooDS Generator v2.1.0 - 2006 CNAM, INT, Filao 
 */

//This class has generated for the server logic.
package basicTypes1.server;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import org.apache.log4j.Category;
import org.mega.gasp.event.DataEvent;
import org.mega.gasp.event.EndEvent;
import org.mega.gasp.event.JoinEvent;
import org.mega.gasp.event.QuitEvent;
import org.mega.gasp.event.StartEvent;
import org.mega.gasp.event.impl.DataEventImpl;
import org.mega.gasp.server.GASPServer;

import basicTypes1.BasicTypes;
import basicTypes1.BasicTypesLists;

public class Server extends GASPServer {

	//GASP logger
	public Category cat;
	//hashtable to store player informations, key aSID, value an object representing player
	public Hashtable players;

	// constructor
	public Server() {
		super();
		init();
		cat = Category.getInstance("GASPLogging");
		cat.debug("Log4J Server Category instanciated");
	}

	// required methods
	public void init() {
		players = new Hashtable();
	}


	public void start() {
		cat.debug("Server START running!");
	}


	public void end() {
		cat.debug("Server STOP running!");
	}


	//GASP event listeners
	public void onStartEvent(StartEvent e) {
		cat.debug(("STARTEVENT received by server: aSID>" + e.getActorSessionID()));
		start();
	}


	public void onEndEvent(EndEvent e) {
		cat.debug(("ENDEVENT received by server: aSID>" + e.getActorSessionID()));
		end();
	}


	public void onJoinEvent(JoinEvent e) {
		cat.debug(("JOINEVENT received by server: aSID>" + e.getActorSessionID() + " username>" + e.getUsername()));
		players.put(("" + e.getActorSessionID()),new Object());
	}


	public void onQuitEvent(QuitEvent e) {
		cat.debug(("QUITEVENT received by server: aSID>" + e.getActorSessionID()));
		players.remove(("" + e.getActorSessionID()));
	}


	public void onDataEvent(DataEvent e) {
		cat.debug(("DATAEVENT received by server: aSID>" + e.getActorSessionID() + " Hashtable size>" + e.getData().size()));
		Hashtable h1 = e.getData();
		int nbObj = h1.size();
		for(int i=0; i <nbObj; i++){
			Object o = h1.get((i + ""));
			treatMessage(o,e.getActorSessionID());
		}
	}


	// treat specifically all custom types objects
	public synchronized void treatMessage(Object o,int senderASID) {
		if (o instanceof BasicTypes) {
			//SERVER communication model: write treatments to BasicTypes object received
		}
		if (o instanceof BasicTypesLists) {
			//SERVER communication model: write treatments to BasicTypesLists object received
		}
	}


	// traditional methods used
	private void notifyToAllPlayers(Object o) {
		cat.debug("notifyAllPlayers called");
		Hashtable h = new Hashtable();
		h.put("0",o);
		DataEvent de = new DataEventImpl(0,h);
		Enumeration e = players.keys();
		while (e.hasMoreElements()) {
			int pid = Integer.parseInt(((String) e.nextElement()));
			sendDataTo(pid,de);
		}
	}


	private void notifyToAllOtherPlayers(Object o,int idSender) {
		cat.debug("notifyToAllOtherPlayers called");
		Hashtable h = new Hashtable();
		h.put("0",o);
		DataEvent de = new DataEventImpl(0,h);
		Enumeration e = players.keys();
		while (e.hasMoreElements()) {
			int pid = Integer.parseInt(((String) e.nextElement()));
			if (idSender == pid) {
				sendDataTo(pid,de);
			}
		}
	}


	private void notifyToRecipients(Object o,short[] recipients) {
		cat.debug("notifyToRecipients called");
		Hashtable h = new Hashtable();
		h.put("0",o);
		DataEvent de = new DataEventImpl(0,h);
		int i = 0;
		while (recipients.length>i) {
			if (players.get(("" + recipients[i])) != null) {
				sendDataTo(recipients[i],de);
			}
			i++;
		}
	}


	private void sendMessageToPlayer(Object o,int playerASID) {
		cat.debug("sendMessageToPlayer called");
		Hashtable h = new Hashtable();
		h.put("0",o);
		DataEvent e = new DataEventImpl(0,h);
		sendDataTo(playerASID,e);
	}


	private void sendMessageToPlayer(Vector v,int playerASID) {
		cat.debug("sendMessageToPlayer called");
		Hashtable h = new Hashtable();
		for(int i=0; i <v.size(); i++){
			h.put(("" + i),v.get(i));
		}
		DataEvent e = new DataEventImpl(0,h);
		sendDataTo(playerASID,e);
	}


}
