/** 
 * MooDS Encoder/Decoder for Flash.
 * Encoding version: 1200
 * @author Generated by MooDS Generator v2.5 - 2006-2010 GASP project 
 */


using System;
using System.IO;
using System.Net;
using System.Collections;
using MiscUtil.IO;

//This class has been generated by MooDS Generator to handle objects
// for binarisation input/output.
namespace objectTypes1{
public class CustomTypes {

	// types
	public static byte TYPE_OBJECTA = 0;
	public static byte TYPE_OBJECTB = 1;


	// encodeData root method
	public static void encodeData(Hashtable h,EndianBinaryWriter dos) {
		dos.WriteInt16(1200);
		dos.WriteInt16((short) h.Count);
		int nbSend = h.Count;
		for(int i=0; i <nbSend; i++){
			Object o = h[""+i];
			if (o is ObjectA) {
				dos.WriteByte(TYPE_OBJECTA);
				encodeObjectA(dos,((ObjectA) o));
			}
			if (o is ObjectB) {
				dos.WriteByte(TYPE_OBJECTB);
				encodeObjectB(dos,((ObjectB) o));
			}
		}
	}


	// decodeData root method
	public static Hashtable decodeData(EndianBinaryReader dis) {
		dis.ReadInt16();
		Hashtable h = new Hashtable();
		short nb = dis.ReadInt16();
		int nbObj = nb;
		while (nb != 0) {
			String key = ""+(nbObj - nb);
			byte type = dis.ReadByte();
			if (type == 0) {
				ObjectA customType = decodeObjectA(dis);
				h.Add(key,customType);
			}
			if (type == 1) {
				ObjectB customType = decodeObjectB(dis);
				h.Add(key,customType);
			}
			nb--;
		}
		return h;
	}


	// encoding method for each custom type
	private static void encodeObjectA(EndianBinaryWriter dos,ObjectA customType) {
		encodeObjectC(dos,customType.getObjectC());
	}


	private static void encodeObjectB(EndianBinaryWriter dos,ObjectB customType) {
		ObjectC[] table1 = customType.getObjectC();
		int table1_l0 = table1.Length;
		dos.WriteInt32((int) table1_l0);
		if (table1_l0>0) {
			for(int i0=0; i0 <table1_l0; i0++){
				 //Write a byte to handle serialization with C++
				dos.writeByte(-1);
				encodeObjectC(dos,table1[i0]);
			}
		}

	}


	private static void encodeObjectC(EndianBinaryWriter dos,ObjectC customType) {
		dos.WriteUTF(customType.getAString());
	}



	// decoding method for each custom type
	public static ObjectA decodeObjectA(EndianBinaryReader dis) {
		ObjectA customType = new ObjectA();

		customType.setObjectC(decodeObjectC(dis));
		return customType;
	}


	public static ObjectB decodeObjectB(EndianBinaryReader dis) {
		ObjectB customType = new ObjectB();

		int table1_l0 = dis.ReadInt32();
		if (table1_l0>0) {
			ObjectC[] table1 = new ObjectC[table1_l0];
			for(int i0=0; i0 <table1_l0; i0++){
					dis.readByte();
					table1[i0] = decodeObjectC(dis);
			}
			customType.setObjectC(table1);
		}
		return customType;
	}


	public static ObjectC decodeObjectC(EndianBinaryReader dis) {
		ObjectC customType = new ObjectC();

		customType.setAString(dis.ReadUTF());
		return customType;
	}



}}
