package tests;

import junit.framework.*;
import objectTypes1.server.*;
import objectTypes1.*;
import java.util.*;
import java.io.*;

/*
    	Tests the exchange between a "hashtable" client and "hashtable" server.
   
FIXME : This class should have test communications that are not available yet for C++.
 	That's why some methods are commented, and other implementation are duplicated from moods-communication-tests-java/src/test/java/test
	directory, which fits with the correct tests we want to launch. 

*/

public class TestObjectTypes1 extends TestCase
{

    /*public void testClientServerObjectTypesExchange () throws Exception
    {

		Properties prop = System.getProperties();
		String basedir = (String) prop.get("baseDirectory");

		File inputFile = new File(basedir+"/target/outObjectTypes1.txt");

        Hashtable serverDecodedMap = transmitHashtable(inputFile);

		Object assumedObjectA = serverDecodedMap.get("0");
		Object assumedObjectB = serverDecodedMap.get("1");
                
        assertTrue(assumedObjectA instanceof ObjectA);
        assertTrue(assumedObjectB instanceof ObjectB);

		System.out.println("assumedObjectA : "+assumedObjectA);
		System.out.println("assumedObjectB : "+assumedObjectB);

		ObjectA objectA = (ObjectA) assumedObjectA;
		ObjectB objectB = (ObjectB) assumedObjectB;

		assertTrue(objectA.getObjectC() != null);
		assertTrue(objectA.getObjectC().equals("un"));

		assertTrue(objectB.getObjectC() != null);
		assertTrue(objectB.getObjectC()[0].getAString().equals("deux"));
		assertTrue(objectB.getObjectC()[1].getAString().equals("trois"));
    }

    private Hashtable transmitHashtable(File fileFromTheClient) throws Exception
    {
            // reads the hashtable from the temp file
            DataInputStream dataInputStream = new DataInputStream(new FileInputStream(fileFromTheClient));
            Hashtable serverDecodedMap = (new objectTypes1.server.CustomTypes()).decodeData(dataInputStream);
            dataInputStream.close();

            return serverDecodedMap;
    }*/

 public void testClientServerObjectExchange () throws Exception
    {
            ObjectA objectA = makeObjectA();
            Hashtable<String, Object> hashtable = new Hashtable<String, Object>();
            hashtable.put("0", objectA);

            Hashtable serverDecodedMap = transmitHashtable(hashtable);
                    
            compareObjectsA(objectA, (ObjectA) serverDecodedMap.get("0"));
    }

    public void testClientServerObjectTypesListsExchange () throws Exception
    {
        	ObjectB objectB = makeObjectB();
            Hashtable<String, Object> hashtable = new Hashtable<String, Object>();
            hashtable.put("0", objectB);

            Hashtable serverDecodedMap = transmitHashtable(hashtable);
            
            compareObjectsB(objectB, (ObjectB) serverDecodedMap.get("0"));
    }

    private Hashtable transmitHashtable(Hashtable totheclient) throws Exception
    {
            File tempFile = TempFileManager.makeTempFile();

            // writes the hashtable to the temp file
            FileOutputStream fileOutputStream = new FileOutputStream(tempFile);
            DataOutputStream dataOutputStream = new DataOutputStream(fileOutputStream);
            objectTypes1.client.CustomTypes.encodeData(totheclient, dataOutputStream);
            dataOutputStream.flush();
            dataOutputStream.close();            
            
            // reads the hashtable from the temp file
            DataInputStream dataInputStream = new DataInputStream(new FileInputStream(tempFile));
            Hashtable serverDecodedMap = (new objectTypes1.server.CustomTypes()).decodeData(dataInputStream);
            dataInputStream.close();

            TempFileManager.removeTempFile(tempFile);

            return serverDecodedMap;
    }


    private ObjectA makeObjectA()
    {
        ObjectA objectA = new ObjectA();
        ObjectC objectC = makeObjectC("toto");
        objectA.setObjectC(objectC);
        
        return objectA;
    }


    private ObjectB makeObjectB()
    {
    	ObjectB objectB = new ObjectB();
    	
        ObjectC[] objectCTab = new ObjectC[2];
        objectCTab[0] = makeObjectC("titi");
        objectCTab[1] = makeObjectC("toto");
       
        objectB.setObjectC(objectCTab);

        return objectB;
    }
    
    private ObjectC makeObjectC(String chaine)
    {
    	ObjectC objectC = new ObjectC();
    	objectC.setAString(chaine);
        return objectC;
    }

    private void compareObjectsA(ObjectA objectA1, ObjectA objectA2)
    {
    	assertTrue(objectA1.getObjectC()!=null);
    	assertTrue(objectA2.getObjectC()!=null);
    	assertEquals(objectA1.getObjectC().getAString(), objectA2.getObjectC().getAString());
    }
    
    private void compareObjectsB(ObjectB objectB1, ObjectB objectB2)
    {
    	
        ObjectC[] objectB1_objectC = objectB1.getObjectC();
        ObjectC[] objectB2_objectC = objectB2.getObjectC();

        assertTrue(objectB1_objectC != null);
        assertTrue(objectB2_objectC != null);
        assertEquals(objectB1_objectC[0].getAString(), objectB2_objectC[0].getAString());
        assertEquals(objectB1_objectC[1].getAString(), objectB2_objectC[1].getAString());
    }



}
