/** 
 * MooDS Encoder/Decoder.
 * Encoding version: 1200
 * @author Generated by MooDS Generator v2.1.0 - 2006-2011 uGASP project 
 */

package basicTypes1.server;

import basicTypes1.*;
import org.ugasp.protocol.moods.CustomTypes;
import java.util.Hashtable;
import java.io.DataOutputStream;
import java.io.DataInputStream;
import java.io.IOException;

// This class has been generated by MooDS Generator to handle hashtables
// for binarisation input/output.
public class CustomTypesImpl implements org.ugasp.protocol.moods.CustomTypes {

	// types
	public final static byte TYPE_BASICTYPES = 0;
	public final static byte TYPE_BASICTYPESLISTS = 1;


	// constructor
	public CustomTypesImpl() {
	}

	// encodeData root method
	public void encodeData(Hashtable h,DataOutputStream dos) throws IOException {
		dos.writeShort(1200);
		dos.writeShort(h.size());
		int nbSend = h.size();
		for(int i=0; i <nbSend; i++){
			Hashtable hs = ((Hashtable) h.get(""+i));
			if (hs.get("type").equals(new Byte(TYPE_BASICTYPES))) {
				dos.writeByte(TYPE_BASICTYPES);
				encodeBasicTypes(dos,hs);
			}
			if (hs.get("type").equals(new Byte(TYPE_BASICTYPESLISTS))) {
				dos.writeByte(TYPE_BASICTYPESLISTS);
				encodeBasicTypesLists(dos,hs);
			}
		}
	}


	// decodeData root method
	public Hashtable decodeData(DataInputStream dis) throws IOException {
		dis.readShort();
		Hashtable h = new Hashtable();
		short nb = dis.readShort();
		int nbObj = nb;
		while (nb != 0) {
			String key = ""+(nbObj - nb);
			byte type = dis.readByte();
			if (type == 0) {
				Hashtable hs = decodeBasicTypes(dis);
				h.put(key,hs);
			}
			if (type == 1) {
				Hashtable hs = decodeBasicTypesLists(dis);
				h.put(key,hs);
			}
			nb--;
		}
		return h;
	}


	// encoding method for each custom type
	private void encodeBasicTypes(DataOutputStream dos,Hashtable h) throws IOException {
		dos.writeByte((((Byte) h.get("aByte"))).byteValue());
		dos.writeShort((((Short) h.get("aShort"))).shortValue());
		dos.writeInt((((Integer) h.get("aInt"))).intValue());
		dos.writeLong((((Long) h.get("aLong"))).longValue());
		dos.writeFloat((((Float) h.get("aFloat"))).floatValue());
		dos.writeDouble((((Double) h.get("aDouble"))).doubleValue());
		dos.writeBoolean((((Boolean) h.get("aBoolean"))).booleanValue());
		dos.writeUTF(((String) h.get("aString")));
		dos.writeChar((((Character) h.get("aChar"))).charValue());
	}


	private void encodeBasicTypesLists(DataOutputStream dos,Hashtable h) throws IOException {
		byte[] table1 = ((byte[]) h.get("aByteList"));
		int table1_l0 = table1.length;
		dos.writeInt((int) table1_l0);
		if (table1_l0>0) {
			for(int i0=0; i0 <table1_l0; i0++){
				dos.writeByte(table1[i0]);
			}
		}
		short[] table2 = ((short[]) h.get("aShortList"));
		int table2_l0 = table2.length;
		dos.writeInt((int) table2_l0);
		if (table2_l0>0) {
			for(int i0=0; i0 <table2_l0; i0++){
				dos.writeShort(table2[i0]);
			}
		}
		int[] table3 = ((int[]) h.get("aIntList"));
		int table3_l0 = table3.length;
		dos.writeInt((int) table3_l0);
		if (table3_l0>0) {
			for(int i0=0; i0 <table3_l0; i0++){
				dos.writeInt(table3[i0]);
			}
		}
		long[] table4 = ((long[]) h.get("aLongList"));
		int table4_l0 = table4.length;
		dos.writeInt((int) table4_l0);
		if (table4_l0>0) {
			for(int i0=0; i0 <table4_l0; i0++){
				dos.writeLong(table4[i0]);
			}
		}
		float[] table5 = ((float[]) h.get("aFloatList"));
		int table5_l0 = table5.length;
		dos.writeInt((int) table5_l0);
		if (table5_l0>0) {
			for(int i0=0; i0 <table5_l0; i0++){
				dos.writeFloat(table5[i0]);
			}
		}
		double[] table6 = ((double[]) h.get("aDoubleList"));
		int table6_l0 = table6.length;
		dos.writeInt((int) table6_l0);
		if (table6_l0>0) {
			for(int i0=0; i0 <table6_l0; i0++){
				dos.writeDouble(table6[i0]);
			}
		}
		boolean[] table7 = ((boolean[]) h.get("aBooleanList"));
		int table7_l0 = table7.length;
		dos.writeInt((int) table7_l0);
		if (table7_l0>0) {
			for(int i0=0; i0 <table7_l0; i0++){
				dos.writeBoolean(table7[i0]);
			}
		}
		char[] table8 = ((char[]) h.get("aCharList"));
		int table8_l0 = table8.length;
		dos.writeInt((int) table8_l0);
		if (table8_l0>0) {
			for(int i0=0; i0 <table8_l0; i0++){
				dos.writeChar(table8[i0]);
			}
		}
		String[] table9 = ((String[]) h.get("aStringList"));
		int table9_l0 = table9.length;
		dos.writeInt((int) table9_l0);
		if (table9_l0>0) {
			for(int i0=0; i0 <table9_l0; i0++){
				dos.writeUTF(table9[i0]);
			}
		}
	}



	// decoding method for each custom type
	public Hashtable decodeBasicTypes(DataInputStream dis) throws IOException {
		Hashtable h = new Hashtable();
		h.put("type",new Byte(TYPE_BASICTYPES));

		h.put("aByte",new Byte(dis.readByte()));
		h.put("aShort",new Short(dis.readShort()));
		h.put("aInt",new Integer(dis.readInt()));
		h.put("aLong",new Long(dis.readLong()));
		h.put("aFloat",new Float(dis.readFloat()));
		h.put("aDouble",new Double(dis.readDouble()));
		h.put("aBoolean",new Boolean(dis.readBoolean()));
		h.put("aString",new String(dis.readUTF()));
		h.put("aChar",new Character(dis.readChar()));
		return h;
	}


	public Hashtable decodeBasicTypesLists(DataInputStream dis) throws IOException {
		Hashtable h = new Hashtable();
		h.put("type",new Byte(TYPE_BASICTYPESLISTS));

		int table1_l0 = dis.readInt();
		if (table1_l0>0) {
			byte[] table1 = new byte[table1_l0];
			for(int i0=0; i0 <table1_l0; i0++){
				table1[i0] = dis.readByte();
			}
			h.put("aByteList",table1);
		}

		int table2_l0 = dis.readInt();
		if (table2_l0>0) {
			short[] table2 = new short[table2_l0];
			for(int i0=0; i0 <table2_l0; i0++){
				table2[i0] = dis.readShort();
			}
			h.put("aShortList",table2);
		}

		int table3_l0 = dis.readInt();
		if (table3_l0>0) {
			int[] table3 = new int[table3_l0];
			for(int i0=0; i0 <table3_l0; i0++){
				table3[i0] = dis.readInt();
			}
			h.put("aIntList",table3);
		}

		int table4_l0 = dis.readInt();
		if (table4_l0>0) {
			long[] table4 = new long[table4_l0];
			for(int i0=0; i0 <table4_l0; i0++){
				table4[i0] = dis.readLong();
			}
			h.put("aLongList",table4);
		}

		int table5_l0 = dis.readInt();
		if (table5_l0>0) {
			float[] table5 = new float[table5_l0];
			for(int i0=0; i0 <table5_l0; i0++){
				table5[i0] = dis.readFloat();
			}
			h.put("aFloatList",table5);
		}

		int table6_l0 = dis.readInt();
		if (table6_l0>0) {
			double[] table6 = new double[table6_l0];
			for(int i0=0; i0 <table6_l0; i0++){
				table6[i0] = dis.readDouble();
			}
			h.put("aDoubleList",table6);
		}

		int table7_l0 = dis.readInt();
		if (table7_l0>0) {
			boolean[] table7 = new boolean[table7_l0];
			for(int i0=0; i0 <table7_l0; i0++){
				table7[i0] = dis.readBoolean();
			}
			h.put("aBooleanList",table7);
		}

		int table8_l0 = dis.readInt();
		if (table8_l0>0) {
			char[] table8 = new char[table8_l0];
			for(int i0=0; i0 <table8_l0; i0++){
				table8[i0] = dis.readChar();
			}
			h.put("aCharList",table8);
		}

		int table9_l0 = dis.readInt();
		if (table9_l0>0) {
			String[] table9 = new String[table9_l0];
			for(int i0=0; i0 <table9_l0; i0++){
				table9[i0] = dis.readUTF();
			}
			h.put("aStringList",table9);
		}

		return h;
	}



}
